Index: linuxgpio.c
===================================================================
--- linuxgpio.c	(revision 0)
+++ linuxgpio.c	(revision 0)
@@ -0,0 +1,347 @@
+/*
+ * avrdude - A Downloader/Uploader for AVR device programmers
+ * Support for bitbanging GPIO pins using the /sys/class/gpio interface
+ * 
+ * Copyright (C) 2013 Radoslav Kolev <radoslav@kolev.info>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+#include "ac_cfg.h"
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <fcntl.h>
+#include <unistd.h>
+#include <errno.h>
+
+#include "avrdude.h"
+#include "avr.h"
+#include "pindefs.h"
+#include "pgm.h"
+#include "bitbang.h"
+
+#if HAVE_LINUXGPIO
+
+/*
+ * GPIO user space helpers
+ *
+ * Copyright 2009 Analog Devices Inc.
+ * Michael Hennerich (hennerich@blackfin.uclinux.org)
+ *
+ * Licensed under the GPL-2 or later
+ */
+ 
+/*
+ * GPIO user space helpers
+ * The following functions are acting on an "unsigned gpio" argument, which corresponds to the 
+ * gpio numbering scheme in the kernel (starting from 0).  
+ * The higher level functions use "int pin" to specify the pins with an offset of 1:
+ * gpio = pin - 1;
+ */
+
+#define GPIO_DIR_IN	0
+#define GPIO_DIR_OUT	1
+ 
+static int linuxgpio_export(unsigned gpio)
+{
+	int fd, len, r;
+	char buf[11];
+ 
+	fd = open("/sys/class/gpio/export", O_WRONLY);
+	if (fd < 0) {
+		perror("Can't open /sys/class/gpio/export");
+		return fd;
+	}
+ 
+	len = snprintf(buf, sizeof(buf), "%d", gpio);
+	r=write(fd, buf, len);
+	close(fd);
+
+	return r; 
+}
+ 
+static int linuxgpio_unexport(unsigned gpio)
+{
+	int fd, len, r;
+	char buf[11];
+ 
+	fd = open("/sys/class/gpio/unexport", O_WRONLY);
+	if (fd < 0) {
+		perror("Can't open /sys/class/gpio/unexport");
+		return fd;
+	}
+ 
+	len = snprintf(buf, sizeof(buf), "%d", gpio);
+	r=write(fd, buf, len);
+	close(fd);
+
+	return r;
+}
+
+static int linuxgpio_openfd(unsigned gpio)
+{
+  char filepath[60];
+
+	snprintf(filepath, sizeof(filepath), "/sys/class/gpio/gpio%d/value", gpio);
+	return (open(filepath, O_RDWR));
+}
+ 
+static int linuxgpio_dir(unsigned gpio, unsigned dir)
+{
+	int fd, r;
+	char buf[60];
+ 
+	snprintf(buf, sizeof(buf), "/sys/class/gpio/gpio%d/direction", gpio);
+ 
+	fd = open(buf, O_WRONLY);
+	if (fd < 0) {
+		perror("Can't open gpioX/direction");
+		return fd;
+	}
+ 
+	if (dir == GPIO_DIR_OUT)
+		r=write(fd, "out", 4);
+	else
+		r=write(fd, "in", 3);
+ 
+	close(fd);
+
+	return r;
+}
+ 
+static int linuxgpio_dir_out(unsigned gpio)
+{
+	return linuxgpio_dir(gpio, GPIO_DIR_OUT);
+}
+ 
+static int linuxgpio_dir_in(unsigned gpio)
+{
+	return linuxgpio_dir(gpio, GPIO_DIR_IN);
+}
+
+/*
+ * End of GPIO user space helpers
+ */
+
+#define N_GPIO 256
+
+/*
+* an array which holds open FDs to /sys/class/gpio/gpioXX/value for all needed pins
+*/
+static int linuxgpio_fds[N_GPIO] ;
+
+
+static int linuxgpio_setpin(PROGRAMMER * pgm, int pin, int value)
+{
+  int r;
+
+  if (pin & PIN_INVERSE)
+  {
+    value  = !value;
+    pin   &= PIN_MASK;
+  }
+
+    if ( linuxgpio_fds[pin] < 0 )
+      return -1;
+
+  if (value)
+    r=write(linuxgpio_fds[pin], "1", 1);
+  else
+    r=write(linuxgpio_fds[pin], "0", 1);
+
+  if (r!=1) return -1;
+
+  if (pgm->ispdelay > 1)
+    bitbang_delay(pgm->ispdelay);
+
+  return 0;
+}
+
+static int linuxgpio_getpin(PROGRAMMER * pgm, int pin)
+{
+  unsigned char invert=0;
+  char c;
+
+  if (pin & PIN_INVERSE)
+  {
+    invert = 1;
+    pin   &= PIN_MASK;
+  }
+
+  if ( linuxgpio_fds[pin] < 0 )
+    return -1;
+
+  if (lseek(linuxgpio_fds[pin], 0, SEEK_SET)<0)
+    return -1;  
+    
+  if (read(linuxgpio_fds[pin], &c, 1)!=1)
+    return -1;    
+    
+  if (c=='0')
+    return 0+invert;
+  else if (c=='1')
+    return 1-invert;
+  else 
+    return -1;
+  
+}
+
+static int linuxgpio_highpulsepin(PROGRAMMER * pgm, int pin)
+{
+
+  if ( linuxgpio_fds[pin & PIN_MASK] < 0 )
+    return -1;
+
+  linuxgpio_setpin(pgm, pin, 1);
+  linuxgpio_setpin(pgm, pin, 0);
+
+  return 0;
+}
+
+
+
+static void linuxgpio_display(PROGRAMMER *pgm, const char *p)
+{
+  /* MAYBE */
+}
+
+static void linuxgpio_enable(PROGRAMMER *pgm)
+{
+  /* nothing */
+}
+
+static void linuxgpio_disable(PROGRAMMER *pgm)
+{
+  /* nothing */
+}
+
+static void linuxgpio_powerup(PROGRAMMER *pgm)
+{
+  /* nothing */
+}
+
+static void linuxgpio_powerdown(PROGRAMMER *pgm)
+{
+  /* nothing */
+}
+
+static int linuxgpio_open(PROGRAMMER *pgm, char *port)
+{
+  int r,i;
+
+  bitbang_check_prerequisites(pgm);
+
+
+  for (i=0; i<N_GPIO; i++) 
+		linuxgpio_fds[i]=-1; 
+  //Avrdude assumes that if a pin number is 0 it means not used/available
+  //this causes a problem because 0 is a valid GPIO number in Linux sysfs.
+  //To avoid annoying off by one pin numbering we assume SCK, MOSI, MISO 
+  //and RESET pins are always defined in avrdude.conf, even as 0. If they're
+  //not programming will not work anyway. The drawbacks of this approach are
+  //that unwanted toggling of GPIO0 can occur and that other optional pins
+  //mostry LED status, can't be set to GPIO0. It can be fixed when a better 
+  //solution exists.
+  for (i=0; i<N_PINS; i++) {
+    if ( pgm->pinno[i] != 0 ||
+         i == PIN_AVR_RESET ||
+         i == PIN_AVR_SCK   ||
+         i == PIN_AVR_MOSI  ||
+         i == PIN_AVR_MISO ) {
+        if ((r=linuxgpio_export(pgm->pinno[i])) < 0) {
+            fprintf(stderr, "Can't export GPIO %d, already exported/busy?: %s",
+                    pgm->pinno[i], strerror(errno));
+	    return r;
+        }
+	if (i == PIN_AVR_MISO)
+	    r=linuxgpio_dir_in(pgm->pinno[i]);
+	else
+	    r=linuxgpio_dir_out(pgm->pinno[i]);
+	    
+	if (r < 0)
+	    return r;
+    
+	if ((linuxgpio_fds[pgm->pinno[i]]=linuxgpio_openfd(pgm->pinno[i]))<0)
+	    return linuxgpio_fds[pgm->pinno[i]];    
+    }
+  }
+  
+ return(0);
+}
+
+static void linuxgpio_close(PROGRAMMER *pgm)
+{
+  int i;
+
+  //first configure all pins as input, except RESET
+  //this should avoid possible conflicts when AVR firmware starts
+  for (i=0; i<N_GPIO; i++) {
+    if (linuxgpio_fds[i]>=0 && i != pgm->pinno[PIN_AVR_RESET]) {
+       close(linuxgpio_fds[i]);       
+       linuxgpio_dir_in(i);
+       linuxgpio_unexport(i);
+    }
+  }
+  //configure RESET as input, if there's external pull up it will go high
+  if (linuxgpio_fds[pgm->pinno[PIN_AVR_RESET]]>=0) {
+    close(linuxgpio_fds[pgm->pinno[PIN_AVR_RESET]]);
+    linuxgpio_dir_in(pgm->pinno[PIN_AVR_RESET]);
+    linuxgpio_unexport(pgm->pinno[PIN_AVR_RESET]);
+  }
+  return;
+}
+
+void linuxgpio_initpgm(PROGRAMMER *pgm)
+{
+  strcpy(pgm->type, "LINUXGPIO");
+
+  pgm->rdy_led        = bitbang_rdy_led;
+  pgm->err_led        = bitbang_err_led;
+  pgm->pgm_led        = bitbang_pgm_led;
+  pgm->vfy_led        = bitbang_vfy_led;
+  pgm->initialize     = bitbang_initialize;
+  pgm->display        = linuxgpio_display;
+  pgm->enable         = linuxgpio_enable;
+  pgm->disable        = linuxgpio_disable;
+  pgm->powerup        = linuxgpio_powerup;
+  pgm->powerdown      = linuxgpio_powerdown;
+  pgm->program_enable = bitbang_program_enable;
+  pgm->chip_erase     = bitbang_chip_erase;
+  pgm->cmd            = bitbang_cmd;
+  pgm->open           = linuxgpio_open;
+  pgm->close          = linuxgpio_close;
+  pgm->setpin         = linuxgpio_setpin;
+  pgm->getpin         = linuxgpio_getpin;
+  pgm->highpulsepin   = linuxgpio_highpulsepin;
+  pgm->read_byte      = avr_read_byte_default;
+  pgm->write_byte     = avr_write_byte_default;
+}
+
+#else  /* !HAVE_LINUXGPIO */
+
+void linuxgpio_initpgm(PROGRAMMER * pgm)
+{
+  fprintf(stderr,
+	  "%s: Linux sysfs GPIO support not available in this configuration\n",
+	  progname);
+}
+
+#endif /* HAVE_LINUXGPIO */
+
+
+const char linuxgpio_desc[] = "GPIO bitbanging using the Linux sysfs interface";
+
Index: linuxgpio.h
===================================================================
--- linuxgpio.h	(revision 0)
+++ linuxgpio.h	(revision 0)
@@ -0,0 +1,36 @@
+/*
+ * avrdude - A Downloader/Uploader for AVR device programmers
+ * Copyright (C) 2013 Radoslav Kolev <radoslav@kolev.info>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+/* $Id: par.h 722 2007-01-24 22:43:46Z joerg_wunsch $ */
+
+#ifndef linuxgpio_h
+#define linuxgpio_h
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+extern const char linuxgpio_desc[];
+void linuxgpio_initpgm        (PROGRAMMER * pgm);
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif
Index: avrdude.conf.in
===================================================================
--- avrdude.conf.in	(revision 1130)
+++ avrdude.conf.in	(working copy)
@@ -1142,7 +1142,28 @@
 
 @HAVE_PARPORT_END@
 
+@HAVE_LINUXGPIO_BEGIN@
+
 #
+#This programmer bitbangs GPIO lines using the Linux sysfs GPIO interface
+#
+#Set the configuration below to match the GPIO lines connected to the
+#relevant ISP header pin.
+#
+
+programmer
+  id    = "linuxgpio";
+  desc  = "Use the Linux sysfs interface to bitbang GPIO lines";
+  type  = "linuxgpio";
+  reset = 11;
+  sck   = 13;
+  mosi  = 12;
+  miso  = 9;  
+;
+
+@HAVE_LINUXGPIO_END@
+
+#
 # some ultra cheap programmers use bitbanging on the 
 # serialport.
 #
Index: Makefile.am
===================================================================
--- Makefile.am	(revision 1130)
+++ Makefile.am	(working copy)
@@ -114,6 +114,8 @@
 	freebsd_ppi.h \
 	ft245r.c \
 	ft245r.h \
+	linuxgpio.c \
+	linuxgpio.h \
 	jtagmkI.c \
 	jtagmkI.h \
 	jtagmkI_private.h \
Index: avrdude.1
===================================================================
--- avrdude.1	(revision 1130)
+++ avrdude.1	(working copy)
@@ -98,6 +98,18 @@
 Connecting to a serial port emulated on top of USB is likely to not
 work at all, or to work abysmally slow.
 .Pp
+If you happen to have a Linux system with at least 4 hardware GPIOs 
+available (like almost all embedded Linux boards) you can do without 
+any additional hardware - just connect them to the MOSI, MISO, RESET 
+and SCK pins on the AVR and use the linuxgpio programmer type. It bitbangs
+the lines using the Linux sysfs GPIO interface. Of course, care should
+be taken about voltage level compatibility. Also, although not strictrly 
+required, it is strongly advisable to protect the GPIO pins from 
+overcurrent situations in some way. The simplest would be to just put
+some resistors in series or better yet use a 3-state buffer driver like
+the 74HC244. Have a look at http://kolev.info/avrdude-linuxgpio for a more
+detailed tutorial about using this programmer type.
+.Pp
 Atmel's STK500 programmer is also supported and connects to a serial
 port.
 Both, firmware versions 1.x and 2.x can be handled, but require a
Index: configure.ac
===================================================================
--- configure.ac	(revision 1130)
+++ configure.ac	(working copy)
@@ -271,6 +271,18 @@
 		*)   AC_MSG_ERROR(bad value ${enableval} for enable-parport option) ;;
 		esac],
 	[enabled_parport=yes])
+	
+AC_ARG_ENABLE(
+	[linuxgpio],
+	AC_HELP_STRING(
+		[--enable-linuxgpio],
+		[Enable the Linux sysfs GPIO interface programmer type]),
+	[case "${enableval}" in
+		yes) enabled_linuxgpio=yes ;;
+		no)  enabled_linuxgpio=no ;;
+		*)   AC_MSG_ERROR(bad value ${enableval} for enable-linuxgpio option) ;;
+		esac],
+	[enabled_linuxgpio=no])	
 
 DIST_SUBDIRS_AC='doc windows'
 
@@ -340,6 +352,15 @@
 	confsubst="-e /^@HAVE_PARPORT_BEGIN@/,/^@HAVE_PARPORT_END@/d"
 fi
 
+
+if test "$enabled_linuxgpio" = "yes"; then
+	AC_DEFINE(HAVE_LINUXGPIO, 1, [Linux sysfs GPIO support enabled])
+	confsubst="$confsubst -e /^@HAVE_LINUXGPIO_/d"
+else
+	confsubst="$confsubst -e /^@HAVE_LINUXGPIO_BEGIN@/,/^@HAVE_LINUXGPIO_END@/d"
+fi
+
+
 # If we are compiling with gcc, enable all warning and make warnings errors.
 if test "$GCC" = yes; then
     ENABLE_WARNINGS="-Wall"
Index: pgm_type.c
===================================================================
--- pgm_type.c	(revision 1130)
+++ pgm_type.c	(working copy)
@@ -35,6 +35,7 @@
 #include "buspirate.h"
 #include "butterfly.h"
 #include "ft245r.h"
+#include "linuxgpio.h"
 #include "jtagmkI.h"
 #include "jtagmkII.h"
 #include "jtag3.h"
@@ -64,6 +65,7 @@
         {"dragon_pdi", jtagmkII_dragon_pdi_initpgm, jtagmkII_dragon_pdi_desc},
         {"dragon_pp", stk500v2_dragon_pp_initpgm, stk500v2_dragon_pp_desc},
         {"ftdi_syncbb", ft245r_initpgm, ft245r_desc},
+        {"linuxgpio", linuxgpio_initpgm, linuxgpio_desc},
         {"jtagmki", jtagmkI_initpgm, jtagmkI_desc},
         {"jtagmkii", jtagmkII_initpgm, jtagmkII_desc},
         {"jtagmkii_avr32", jtagmkII_avr32_initpgm, jtagmkII_avr32_desc},
Index: doc/avrdude.texi
===================================================================
--- doc/avrdude.texi	(revision 1130)
+++ doc/avrdude.texi	(working copy)
@@ -168,6 +168,18 @@
 emulated on top of USB is likely to not work at all, or to work
 abysmally slow.
 
+If you happen to have a Linux system with at least 4 hardware GPIOs 
+available (like almost all embedded Linux boards) you can do without 
+any additional hardware - just connect them to the MOSI, MISO, RESET 
+and SCK pins on the AVR and use the linuxgpio programmer type. It bitbangs
+the lines using the Linux sysfs GPIO interface. Of course, care should
+be taken about voltage level compatibility. Also, although not strictrly 
+required, it is strongly advisable to protect the GPIO pins from 
+overcurrent situations in some way. The simplest would be to just put
+some resistors in series or better yet use a 3-state buffer driver like
+the 74HC244. Have a look at http://kolev.info/avrdude-linuxgpio for a more
+detailed tutorial about using this programmer type.
+
 The STK500, JTAG ICE, avr910, and avr109/butterfly use the serial port to communicate with the PC.
 The STK600, JTAG ICE mkII, AVRISP mkII, USBasp, avrftdi (and derivitives), and USBtinyISP
 programmers communicate through the USB, using @code{libusb} as a
Index: NEWS
===================================================================
--- NEWS	(revision 1130)
+++ NEWS	(working copy)
@@ -14,6 +14,10 @@
     - ATmega256RFR2, ATmega128RFR2, ATmega64RFR2
 
   * New programmers supported:
+    - linuxgpio
+      + any (embedded) Linux system with 4 GPIOs available can be used
+        as a programmer with little or no additional hardware.
+
     - avrftdi
       + o-link (patch #7672 adding support for O-Link (FTDI based
         JTAG) as programmer)
Index: config_gram.y
===================================================================
--- config_gram.y	(revision 1130)
+++ config_gram.y	(working copy)
@@ -1346,10 +1346,10 @@
   value = v->value.number;
   free_token(v);
 
-  if ((value <= 0) || (value >= 18)) {
+  if ((value <= 0) || (value > 255)) {
     fprintf(stderr, 
             "%s: error at line %d of %s: pin must be in the "
-            "range 1-17\n",
+            "range 1-255\n",
             progname, lineno, infile);
     exit(1);
   }