diff --git i/frontend/php/account/login.php w/frontend/php/account/login.php
index 3e4c084..e8974c0 100644
--- i/frontend/php/account/login.php
+++ w/frontend/php/account/login.php
@@ -227,7 +227,7 @@ if (isset($GLOBALS['sys_https_host']))
 
   print '<p><input type="checkbox" name="stay_in_ssl" value="1" tabindex="1" '.$checked.'/><span class="preinput">';
   print _("Stay in secure (https) mode after login")."</span><br />\n";
-  print '<span class="text">'._("Lynx, Emacs w3 and Microsoft Internet Explorer users will have intermittent https problems, so they should leave https after login. Gecko-based browser (Mozilla, Galeon, Netscape...) and Konqueror users should stay in https mode permanently for maximum security.").'</span></p>';
+  print '<span class="text">'._("Lynx, Emacs, w3, and Microsoft Internet Explorer users will have intermittent https problems, so they should leave https after login. Gecko-based browser (Mozilla, Galeon, Netscape...) and Konqueror users should stay in https mode permanently for maximum security.").'</span></p>';
 }
 else
 {
diff --git i/po/ca.po w/po/ca.po
index ee9cb1e..3a32ce4 100644
--- i/po/ca.po
+++ w/po/ca.po
@@ -226,7 +226,7 @@ msgstr "Mantingues el mode segur (https) desprÃ©s de l'inici"
 
 #: frontend/php/account/login.php:230
 msgid ""
-"Lynx, Emacs w3 and Microsoft Internet Explorer users will have intermittent "
+"Lynx, Emacs, w3, and Microsoft Internet Explorer users will have intermittent "
 "https problems, so they should leave https after login. Gecko-based browser "
 "(Mozilla, Galeon, Netscape...) and Konqueror users should stay in https mode "
 "permanently for maximum security."
diff --git i/po/de.po w/po/de.po
index c7fe49f..9fd3b89 100644
--- i/po/de.po
+++ w/po/de.po
@@ -213,7 +213,7 @@ msgid "Stay in secure (https) mode after login"
 msgstr "Nach der Anmeldung im sicheren Modus (HTTPS) bleiben"
 
 #: ../frontend/php/account/login.php:222
-msgid "Lynx, Emacs w3 and Microsoft Internet Explorer users will have intermittent https problems, so they should leave https after login. Gecko-based browser (Mozilla, Galeon, Netscape...) and Konqueror users should stay in https mode permanently for maximum security."
+msgid "Lynx, Emacs, w3, and Microsoft Internet Explorer users will have intermittent https problems, so they should leave https after login. Gecko-based browser (Mozilla, Galeon, Netscape...) and Konqueror users should stay in https mode permanently for maximum security."
 msgstr "Benutzer von Lynx, Emacs W3 und Microsoft Internet Explorer haben zeitweise Probleme mit der HTTPS-Verbindung und sollten nach der Anmeldung den HTTPS-Modus verlassen. Benutzer von Gecko-basierten Webbrowsern (Mozilla, Galeon, Netscape&hellip;) sowie Benutzer von Konqueror sollten dauerhaft im HTTPS-Modus zur maximale Sicherheit bleiben."
 
 #: ../frontend/php/account/login.php:227
diff --git i/po/es.po w/po/es.po
index 8536693..c59c07e 100644
--- i/po/es.po
+++ w/po/es.po
@@ -171,7 +171,7 @@ msgid "Stay in secure (https) mode after login"
 msgstr "Seguir en modo seguro (https) despuÃ©s de entrar al sistema"
 
 #: frontend/php/account/login.php:230
-msgid "Lynx, Emacs w3 and Microsoft Internet Explorer users will have intermittent https problems, so they should leave https after login. Gecko-based browser (Mozilla, Galeon, Netscape...) and Konqueror users should stay in https mode permanently for maximum security."
+msgid "Lynx, Emacs, w3, and Microsoft Internet Explorer users will have intermittent https problems, so they should leave https after login. Gecko-based browser (Mozilla, Galeon, Netscape...) and Konqueror users should stay in https mode permanently for maximum security."
 msgstr "Los usuarios de Lynx, Emacs w3 y Microsoft Internet Explorer tendrÃ¡n problemas https intermitentes, por eso deberÃ­an abandonar https despues de entrar al sistema. Los usuarios de navegadores Gecko-based (Mozilla, Galeon, Netscape...) y Konqueror deberÃ­an quedarse en modo https permanentemente para mÃ¡xima seguridad."
 
 #: frontend/php/account/login.php:235
diff --git i/po/fr.po w/po/fr.po
index 326b8f3..05fb8d6 100644
--- i/po/fr.po
+++ w/po/fr.po
@@ -242,7 +242,7 @@ msgstr "Rester connect
 
 #: frontend/php/account/login.php:230
 msgid ""
-"Lynx, Emacs w3 and Microsoft Internet Explorer users will have intermittent "
+"Lynx, Emacs, w3, and Microsoft Internet Explorer users will have intermittent "
 "https problems, so they should leave https after login. Gecko-based browser "
 "(Mozilla, Galeon, Netscape...) and Konqueror users should stay in https mode "
 "permanently for maximum security."
diff --git i/po/it.po w/po/it.po
index 8ad462e..c99dccf 100644
--- i/po/it.po
+++ w/po/it.po
@@ -212,7 +212,7 @@ msgstr "Rimani in modalit
 
 #: frontend/php/account/login.php:230
 msgid ""
-"Lynx, Emacs w3 and Microsoft Internet Explorer users will have intermittent "
+"Lynx, Emacs, w3, and Microsoft Internet Explorer users will have intermittent "
 "https problems, so they should leave https after login. Gecko-based browser "
 "(Mozilla, Galeon, Netscape...) and Konqueror users should stay in https mode "
 "permanently for maximum security."
diff --git i/po/ja.po w/po/ja.po
index 7e9c4dc..aab9538 100644
--- i/po/ja.po
+++ w/po/ja.po
@@ -211,7 +211,7 @@ msgstr "
 #: frontend/php/account/login.php:230
 #, fuzzy
 msgid ""
-"Lynx, Emacs w3 and Microsoft Internet Explorer users will have intermittent "
+"Lynx, Emacs, w3, and Microsoft Internet Explorer users will have intermittent "
 "https problems, so they should leave https after login. Gecko-based browser "
 "(Mozilla, Galeon, Netscape...) and Konqueror users should stay in https mode "
 "permanently for maximum security."
diff --git i/po/pt_BR.po w/po/pt_BR.po
index ce31f7b..723b21e 100644
--- i/po/pt_BR.po
+++ w/po/pt_BR.po
@@ -218,7 +218,7 @@ msgstr "Permanecer em modo SSL depois do login"
 #: frontend/php/account/login.php:230
 #, fuzzy
 msgid ""
-"Lynx, Emacs w3 and Microsoft Internet Explorer users will have intermittent "
+"Lynx, Emacs, w3, and Microsoft Internet Explorer users will have intermittent "
 "https problems, so they should leave https after login. Gecko-based browser "
 "(Mozilla, Galeon, Netscape...) and Konqueror users should stay in https mode "
 "permanently for maximum security."
diff --git i/po/ru.po w/po/ru.po
index c9b2e17..c92092e 100644
--- i/po/ru.po
+++ w/po/ru.po
@@ -216,7 +216,7 @@ msgid "Stay in secure (https) mode after login"
 msgstr "ïÓÔÁ×ÁÔØÓÑ × ÂÅÚÏÐÁÓÎÏÍ (https) ÒÅÖÉÍÅ ÐÏÓÌÅ ×ÈÏÄÁ"
 
 #: ../frontend/php/account/login.php:222
-msgid "Lynx, Emacs w3 and Microsoft Internet Explorer users will have intermittent https problems, so they should leave https after login. Gecko-based browser (Mozilla, Galeon, Netscape...) and Konqueror users should stay in https mode permanently for maximum security."
+msgid "Lynx, Emacs, w3, and Microsoft Internet Explorer users will have intermittent https problems, so they should leave https after login. Gecko-based browser (Mozilla, Galeon, Netscape...) and Konqueror users should stay in https mode permanently for maximum security."
 msgstr ""
 
 #: ../frontend/php/account/login.php:227
diff --git i/po/sv.po w/po/sv.po
index 607942d..b9cb59e 100644
--- i/po/sv.po
+++ w/po/sv.po
@@ -200,7 +200,7 @@ msgstr "Forts
 
 #: frontend/php/account/login.php:230
 msgid ""
-"Lynx, Emacs w3 and Microsoft Internet Explorer users will have intermittent "
+"Lynx, Emacs, w3, and Microsoft Internet Explorer users will have intermittent "
 "https problems, so they should leave https after login. Gecko-based browser "
 "(Mozilla, Galeon, Netscape...) and Konqueror users should stay in https mode "
 "permanently for maximum security."