Index: lwip/src/core/mem.c
===================================================================
RCS file: /sources/lwip/lwip/src/core/mem.c,v
retrieving revision 1.40
diff -u -p -r1.40 mem.c
--- lwip/src/core/mem.c	22 May 2007 19:38:12 -0000	1.40
+++ lwip/src/core/mem.c	13 Jun 2007 06:15:12 -0000
@@ -136,7 +136,7 @@ mem_init(void)
 
   /* align the heap */
   memset(ram_heap, 0, sizeof(ram_heap));
-  ram = MEM_ALIGN(ram_heap);
+  ram = LWIP_MEM_ALIGN(ram_heap);
   /* initialize the start of the heap */
   mem = (struct mem *)ram;
   mem->next = MEM_SIZE_ALIGNED;
Index: lwip/src/core/memp.c
===================================================================
RCS file: /sources/lwip/lwip/src/core/memp.c,v
retrieving revision 1.40
diff -u -p -r1.40 memp.c
--- lwip/src/core/memp.c	7 Jun 2007 21:36:20 -0000	1.40
+++ lwip/src/core/memp.c	13 Jun 2007 06:15:12 -0000
@@ -217,7 +217,7 @@ memp_overflow_check_all(void)
   u16_t i, j;
   struct memp *p;
 
-  p = MEM_ALIGN(memp_memory);
+  p = LWIP_MEM_ALIGN(memp_memory);
   for (i = 0; i < MEMP_MAX; ++i) {
     p = p;
     for (j = 0; j < memp_num[i]; ++j) {
@@ -236,7 +236,7 @@ memp_overflow_init(void)
   struct memp *p;
   u8_t *m;
 
-  p = MEM_ALIGN(memp_memory);
+  p = LWIP_MEM_ALIGN(memp_memory);
   for (i = 0; i < MEMP_MAX; ++i) {
     p = p;
     for (j = 0; j < memp_num[i]; ++j) {
@@ -271,7 +271,7 @@ memp_init(void)
   }
 #endif /* MEMP_STATS */
 
-  memp = MEM_ALIGN(memp_memory);
+  memp = LWIP_MEM_ALIGN(memp_memory);
   /* for every pool: */
   for (i = 0; i < MEMP_MAX; ++i) {
     memp_tab[i] = NULL;
Index: lwip/src/core/pbuf.c
===================================================================
RCS file: /sources/lwip/lwip/src/core/pbuf.c,v
retrieving revision 1.104
diff -u -p -r1.104 pbuf.c
--- lwip/src/core/pbuf.c	8 Jun 2007 17:27:36 -0000	1.104
+++ lwip/src/core/pbuf.c	13 Jun 2007 06:15:13 -0000
@@ -158,7 +158,7 @@ pbuf_alloc(pbuf_layer l, u16_t length, p
     p->next = NULL;
 
     /* make the payload pointer point 'offset' bytes into pbuf data memory */
-    p->payload = MEM_ALIGN((void *)((u8_t *)p + (SIZEOF_STRUCT_PBUF + offset)));
+    p->payload = LWIP_MEM_ALIGN((void *)((u8_t *)p + (SIZEOF_STRUCT_PBUF + offset)));
     LWIP_ASSERT("pbuf_alloc: pbuf p->payload properly aligned",
             ((mem_ptr_t)p->payload % MEM_ALIGNMENT) == 0);
     /* the total length of the pbuf chain is the requested size */
@@ -218,7 +218,7 @@ pbuf_alloc(pbuf_layer l, u16_t length, p
       return NULL;
     }
     /* Set up internal structure of the pbuf. */
-    p->payload = MEM_ALIGN((void *)((u8_t *)p + SIZEOF_STRUCT_PBUF + offset));
+    p->payload = LWIP_MEM_ALIGN((void *)((u8_t *)p + SIZEOF_STRUCT_PBUF + offset));
     p->len = p->tot_len = length;
     p->next = NULL;
     p->flags = PBUF_FLAG_RAM;
Index: lwip/src/core/ipv4/ip_frag.c
===================================================================
RCS file: /sources/lwip/lwip/src/core/ipv4/ip_frag.c,v
retrieving revision 1.30
diff -u -p -r1.30 ip_frag.c
--- lwip/src/core/ipv4/ip_frag.c	8 Jun 2007 22:20:59 -0000	1.30
+++ lwip/src/core/ipv4/ip_frag.c	13 Jun 2007 06:15:13 -0000
@@ -361,7 +361,7 @@ ip_frag(struct pbuf *p, struct netif *ne
     return ERR_MEM;
   }
   rambuf->tot_len = rambuf->len = mtu;
-  rambuf->payload = MEM_ALIGN((void *)buf);
+  rambuf->payload = LWIP_MEM_ALIGN((void *)buf);
 
   /* Copy the IP header in it */
   iphdr = rambuf->payload;
Index: lwip/src/include/lwip/mem.h
===================================================================
RCS file: /sources/lwip/lwip/src/include/lwip/mem.h,v
retrieving revision 1.13
diff -u -p -r1.13 mem.h
--- lwip/src/include/lwip/mem.h	11 May 2007 19:42:14 -0000	1.13
+++ lwip/src/include/lwip/mem.h	13 Jun 2007 06:15:14 -0000
@@ -78,7 +78,7 @@ void *mem_realloc(void *mem, mem_size_t 
 #endif
 
 #ifndef MEM_ALIGN
-#define MEM_ALIGN(addr) ((void *)(((mem_ptr_t)(addr) + MEM_ALIGNMENT - 1) & ~(mem_ptr_t)(MEM_ALIGNMENT-1)))
+#define LWIP_MEM_ALIGN(addr) ((void *)(((mem_ptr_t)(addr) + MEM_ALIGNMENT - 1) & ~(mem_ptr_t)(MEM_ALIGNMENT-1)))
 #endif
 
 #ifdef __cplusplus
Index: lwip/src/netif/ppp/vj.c
===================================================================
RCS file: /sources/lwip/lwip/src/netif/ppp/vj.c,v
retrieving revision 1.7
diff -u -p -r1.7 vj.c
--- lwip/src/netif/ppp/vj.c	10 May 2007 05:20:06 -0000	1.7
+++ lwip/src/netif/ppp/vj.c	13 Jun 2007 06:15:14 -0000
@@ -586,7 +586,7 @@ int vj_uncompress_tcp(
         }
         
         
-	if(MEM_ALIGN(n0->payload) != n0->payload) {
+	if(LWIP_MEM_ALIGN(n0->payload) != n0->payload) {
 		struct pbuf *np, *q;
 		u8_t *bufptr;
 