Index: core/inet.c
===================================================================
RCS file: /home/ncvs/stl9311/exp/avatar/rtl8019/dos/lwip/src/core/inet.c,v
retrieving revision 1.4
diff -u -p -r1.4 inet.c
--- core/inet.c	2 Jan 2007 05:38:36 -0000	1.4
+++ core/inet.c	14 Feb 2007 01:28:34 -0000
@@ -434,7 +434,7 @@ inet_aton(const char *cp, struct in_addr
     break;
 
   case 2:             /* a.b -- 8.24 bits */
-    if (val > 0xffffff)
+    if (val > 0xffffffUL)
       return (0);
     val |= parts[0] << 24;
     break;
@@ -524,8 +524,8 @@ htonl(u32_t n)
 {
   return ((n & 0xff) << 24) |
     ((n & 0xff00) << 8) |
-    ((n & 0xff0000) >> 8) |
-    ((n & 0xff000000) >> 24);
+    ((n & 0xff0000UL) >> 8) |
+    ((n & 0xff000000UL) >> 24);
 }
 
 u32_t
Index: include/ipv4/lwip/ip_addr.h
===================================================================
RCS file: /home/ncvs/stl9311/exp/avatar/rtl8019/dos/lwip/src/include/ipv4/lwip/ip_addr.h,v
retrieving revision 1.4
diff -u -p -r1.4 ip_addr.h
--- include/ipv4/lwip/ip_addr.h	2 Jan 2007 05:24:30 -0000	1.4
+++ include/ipv4/lwip/ip_addr.h	14 Feb 2007 01:28:34 -0000
@@ -78,39 +78,39 @@ extern const struct ip_addr ip_addr_broa
 #define IP_ADDR_ANY         ((struct ip_addr *)&ip_addr_any)
 #define IP_ADDR_BROADCAST   ((struct ip_addr *)&ip_addr_broadcast)
 
-#define INADDR_NONE         ((u32_t)0xffffffff)  /* 255.255.255.255 */
-#define INADDR_LOOPBACK     ((u32_t)0x7f000001)  /* 127.0.0.1 */
+#define INADDR_NONE         ((u32_t)0xffffffffUL)  /* 255.255.255.255 */
+#define INADDR_LOOPBACK     ((u32_t)0x7f000001UL)  /* 127.0.0.1 */
 
 /* Definitions of the bits in an Internet address integer.
 
    On subnets, host and network parts are found according to
    the subnet mask, not these masks.  */
 
-#define IN_CLASSA(a)        ((((u32_t)(a)) & 0x80000000) == 0)
+#define IN_CLASSA(a)        ((((u32_t)(a)) & 0x80000000UL) == 0)
 #define IN_CLASSA_NET       0xff000000
 #define IN_CLASSA_NSHIFT    24
 #define IN_CLASSA_HOST      (0xffffffff & ~IN_CLASSA_NET)
 #define IN_CLASSA_MAX       128
 
-#define IN_CLASSB(a)        ((((u32_t)(a)) & 0xc0000000) == 0x80000000)
+#define IN_CLASSB(a)        ((((u32_t)(a)) & 0xc0000000UL) == 0x80000000UL)
 #define IN_CLASSB_NET       0xffff0000
 #define IN_CLASSB_NSHIFT    16
 #define IN_CLASSB_HOST      (0xffffffff & ~IN_CLASSB_NET)
 #define IN_CLASSB_MAX       65536
 
-#define IN_CLASSC(a)        ((((u32_t)(a)) & 0xe0000000) == 0xc0000000)
+#define IN_CLASSC(a)        ((((u32_t)(a)) & 0xe0000000UL) == 0xc0000000UL)
 #define IN_CLASSC_NET       0xffffff00
 #define IN_CLASSC_NSHIFT    8
 #define IN_CLASSC_HOST      (0xffffffff & ~IN_CLASSC_NET)
 
-#define IN_CLASSD(a)        (((u32_t)(a) & 0xf0000000) == 0xe0000000)
+#define IN_CLASSD(a)        (((u32_t)(a) & 0xf0000000UL) == 0xe0000000UL)
 #define IN_CLASSD_NET       0xf0000000          /* These ones aren't really */
 #define IN_CLASSD_NSHIFT    28                  /*   net and host fields, but */
 #define IN_CLASSD_HOST      0x0fffffff          /*   routing needn't know. */
 #define IN_MULTICAST(a)     IN_CLASSD(a)
 
-#define IN_EXPERIMENTAL(a)  (((u32_t)(a) & 0xf0000000) == 0xf0000000)
-#define IN_BADCLASS(a)      (((u32_t)(a) & 0xf0000000) == 0xf0000000)
+#define IN_EXPERIMENTAL(a)  (((u32_t)(a) & 0xf0000000UL) == 0xf0000000UL)
+#define IN_BADCLASS(a)      (((u32_t)(a) & 0xf0000000UL) == 0xf0000000UL)
 
 #define IN_LOOPBACKNET      127                 /* official! */
 
@@ -141,7 +141,7 @@ extern const struct ip_addr ip_addr_broa
 
 u8_t ip_addr_isbroadcast(struct ip_addr *, struct netif *);
 
-#define ip_addr_ismulticast(addr1) (((addr1)->addr & ntohl(0xf0000000)) == ntohl(0xe0000000))
+#define ip_addr_ismulticast(addr1) (((addr1)->addr & ntohl(0xf0000000UL)) == ntohl(0xe0000000UL))
 
 #define ip_addr_debug_print(debug, ipaddr) \
         LWIP_DEBUGF(debug, ("%"U16_F".%"U16_F".%"U16_F".%"U16_F, \
Index: include/lwip/sockets.h
===================================================================
RCS file: /home/ncvs/stl9311/exp/avatar/rtl8019/dos/lwip/src/include/lwip/sockets.h,v
retrieving revision 1.1.1.1
diff -u -p -r1.1.1.1 sockets.h
--- include/lwip/sockets.h	11 Dec 2006 08:42:50 -0000	1.1.1.1
+++ include/lwip/sockets.h	14 Feb 2007 01:28:34 -0000
@@ -159,10 +159,10 @@ struct linger {
  * we restrict parameters to at most 128 bytes.
  */
 #if !defined(FIONREAD) || !defined(FIONBIO)
-#define IOCPARM_MASK    0x7f            /* parameters must be < 128 bytes */
-#define IOC_VOID        0x20000000      /* no parameters */
-#define IOC_OUT         0x40000000      /* copy out parameters */
-#define IOC_IN          0x80000000      /* copy in parameters */
+#define IOCPARM_MASK    0x7fU           /* parameters must be < 128 bytes */
+#define IOC_VOID        0x20000000UL    /* no parameters */
+#define IOC_OUT         0x40000000UL    /* copy out parameters */
+#define IOC_IN          0x80000000UL    /* copy in parameters */
 #define IOC_INOUT       (IOC_IN|IOC_OUT)
                                         /* 0x20000000 distinguishes new &
                                            old ioctl's */
Index: include/lwip/sys.h
===================================================================
RCS file: /home/ncvs/stl9311/exp/avatar/rtl8019/dos/lwip/src/include/lwip/sys.h,v
retrieving revision 1.4
diff -u -p -r1.4 sys.h
--- include/lwip/sys.h	2 Jan 2007 05:24:31 -0000	1.4
+++ include/lwip/sys.h	14 Feb 2007 01:28:34 -0000
@@ -64,7 +64,7 @@ struct sys_timeo {u8_t dummy;};
 #include "arch/sys_arch.h"
 
 /** Return code for timeouts from sys_arch_mbox_fetch and sys_arch_sem_wait */
-#define SYS_ARCH_TIMEOUT 0xffffffff
+#define SYS_ARCH_TIMEOUT 0xffffffffUL
 
 typedef void (* sys_timeout_handler)(void *arg);
 
Index: include/lwip/tcp.h
===================================================================
RCS file: /home/ncvs/stl9311/exp/avatar/rtl8019/dos/lwip/src/include/lwip/tcp.h,v
retrieving revision 1.1.1.2
diff -u -p -r1.1.1.2 tcp.h
--- include/lwip/tcp.h	2 Jan 2007 05:14:58 -0000	1.1.1.2
+++ include/lwip/tcp.h	14 Feb 2007 01:28:34 -0000
@@ -152,7 +152,7 @@ void             tcp_rexmit_rto  (struct
 
 #define TCP_OOSEQ_TIMEOUT        6U /* x RTO */
 
-#define TCP_MSL 60000  /* The maximum segment lifetime in microseconds */
+#define TCP_MSL 60000U /* The maximum segment lifetime in microseconds */
 
 /*
  * User-settable options (used with setsockopt).
@@ -161,8 +161,8 @@ void             tcp_rexmit_rto  (struct
 #define TCP_KEEPALIVE  0x02    /* send KEEPALIVE probes when idle for pcb->keepalive miliseconds */
 
 /* Keepalive values */
-#define  TCP_KEEPDEFAULT   7200000                       /* KEEPALIVE timer in miliseconds */
-#define  TCP_KEEPINTVL     75000                         /* Time between KEEPALIVE probes in miliseconds */
+#define  TCP_KEEPDEFAULT   7200000UL                     /* KEEPALIVE timer in miliseconds */
+#define  TCP_KEEPINTVL     75000UL                       /* Time between KEEPALIVE probes in miliseconds */
 #define  TCP_KEEPCNT       9                             /* Counter for KEEPALIVE probes */
 #define  TCP_MAXIDLE       TCP_KEEPCNT * TCP_KEEPINTVL   /* Maximum KEEPALIVE probe time */
 